<div *ngFor="let key of keys" class="property">
  <div class="property-key" *ngIf="!inputIsArray()" [ngClass]="{'is-parent': isParent && isPropertyObjectOrArray(key)}"
    (click)="toggleProperty(key)">
    <ng-container *ngIf="isParent && isPropertyObjectOrArray(key)">
      <span class="icon-chevron" *ngIf="isOpenProperties[key]">
        <svg class="icon-opened" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 15 9">
          <path
            d="M7.5 7.5c-.1 0-.3-.1-.4-.1l-6-6C1 1.1 1 .8 1.1.6s.5-.2.7 0l5.6 5.6L13 .6c.2-.2.5-.2.7 0s.2.5 0 .7l-6 6c.1.1-.1.2-.2.2z" />
          <path
            d="M7.5 7.5c-.1 0-.3-.1-.4-.1l-6-6C1 1.1 1 .8 1.1.6s.5-.2.7 0l5.6 5.6L13 .6c.2-.2.5-.2.7 0s.2.5 0 .7l-6 6c.1.1-.1.2-.2.2z" />
        </svg>
      </span>
      <span class="icon-chevron" *ngIf="!isOpenProperties[key]">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 15 9">
          <path
            d="M7.5 7.5c-.1 0-.3-.1-.4-.1l-6-6C1 1.1 1 .8 1.1.6s.5-.2.7 0l5.6 5.6L13 .6c.2-.2.5-.2.7 0s.2.5 0 .7l-6 6c.1.1-.1.2-.2.2z" />
          <path
            d="M7.5 7.5c-.1 0-.3-.1-.4-.1l-6-6C1 1.1 1 .8 1.1.6s.5-.2.7 0l5.6 5.6L13 .6c.2-.2.5-.2.7 0s.2.5 0 .7l-6 6c.1.1-.1.2-.2.2z" />
        </svg>
      </span>
    </ng-container>
    <span>{{ key }}</span>
    <div class="complex-property-warning"
      *ngIf="(getTypeOfProperty(key) === 'array' || getTypeOfProperty(key) === 'object') && !isOpenProperties[key]">
      <svg xmlns="http://www.w3.org/2000/svg" width="16" height="14" fill="none" viewBox="0 0 16 14">
        <path
          d="M15.581 12.031c.146.292.191.584.137.875-.055.31-.2.565-.438.766-.237.219-.52.328-.848.328H1.308c-.329 0-.611-.11-.848-.328a1.26 1.26 0 0 1-.438-.766 1.356 1.356 0 0 1 .137-.875L6.722.656c.164-.291.392-.483.683-.574.31-.11.61-.11.903 0 .31.091.546.283.71.574l6.563 11.375zM7.87 9.68c-.346 0-.647.127-.902.383a1.19 1.19 0 0 0-.356.874c0 .347.119.648.356.903.255.237.556.355.902.355s.638-.118.875-.355c.255-.255.383-.556.383-.902 0-.347-.128-.639-.383-.876a1.147 1.147 0 0 0-.875-.382zM6.667 5.168l.219 3.719c0 .073.027.146.082.218a.4.4 0 0 0 .246.082h1.312a.296.296 0 0 0 .219-.082c.073-.072.11-.145.11-.218l.218-3.719c0-.11-.036-.191-.11-.246a.26.26 0 0 0-.218-.11h-1.75a.34.34 0 0 0-.246.11c-.055.055-.082.137-.082.246z" />
      </svg>
      <span class="warning-complexity" i18n="@@dataset.data.complexProperty">Complex property</span>
    </div>
  </div>
  <div class="property-child" [ngClass]="{'is-hidden': (!isOpenProperties[key] && isParent)}">
    <ng-container [ngSwitch]="getTypeOfProperty(key)">
      <div *ngSwitchCase="'object'" class="complex-property-child">
        <app-dataset-data-detail-properties [properties]="properties[key]" [isParent]="false">
        </app-dataset-data-detail-properties>
      </div>
      <div *ngSwitchCase="'array'" class="complex-property-child">
        <app-dataset-data-detail-properties [properties]="properties[key]" [isParent]="false">
        </app-dataset-data-detail-properties>
      </div>
      <!-- Display the value. If it is url, display a link -->
      <div *ngSwitchDefault class="property-value">
        <span *ngIf="isFloat(properties[key]) && !isUrl(properties[key])">{{ roundTo(properties[key], 2) }}</span>
        <span *ngIf="!isFloat(properties[key]) && !isUrl(properties[key])">{{ (properties[key] && properties[key] !== '') ? properties[key] : '-'  }}</span>
        <a [href]="properties[key]" target="_blank" *ngIf="isUrl(properties[key])">{{ properties[key] }}</a>
      </div>
    </ng-container>
  </div>
</div>
